------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
private with Ada.Finalization;
with Qt4.Chars;
with Qt4.Fonts;
with Qt4.Rects;
with Qt4.Strings;
private with Qt_Ada.Internals.Value_Class_Sizes;

package Qt4.Font_Metrics is

   type Q_Font_Metrics (<>) is tagged private;

   function Create
    (Font : Qt4.Fonts.Q_Font'Class)
       return Q_Font_Metrics;

   function Ascent
    (Self : Q_Font_Metrics'Class)
       return Qt4.Q_Integer;

   function Average_Char_Width
    (Self : Q_Font_Metrics'Class)
       return Qt4.Q_Integer;

   function Bounding_Rect
    (Self : Q_Font_Metrics'Class;
     Ch : Qt4.Chars.Q_Char'Class)
       return Qt4.Rects.Q_Rect;

   function Bounding_Rect
    (Self : Q_Font_Metrics'Class;
     Text : Qt4.Strings.Q_String'Class)
       return Qt4.Rects.Q_Rect;

   function Char_Width
    (Self : Q_Font_Metrics'Class;
     Str : Qt4.Strings.Q_String'Class;
     Pos : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Descent
    (Self : Q_Font_Metrics'Class)
       return Qt4.Q_Integer;

   function Height
    (Self : Q_Font_Metrics'Class)
       return Qt4.Q_Integer;

   function In_Font
    (Self : Q_Font_Metrics'Class;
     Ch : Qt4.Chars.Q_Char'Class)
       return Boolean;

   function Leading
    (Self : Q_Font_Metrics'Class)
       return Qt4.Q_Integer;

   function Left_Bearing
    (Self : Q_Font_Metrics'Class;
     Ch : Qt4.Chars.Q_Char'Class)
       return Qt4.Q_Integer;

   function Line_Spacing
    (Self : Q_Font_Metrics'Class)
       return Qt4.Q_Integer;

   function Line_Width
    (Self : Q_Font_Metrics'Class)
       return Qt4.Q_Integer;

   function Max_Width
    (Self : Q_Font_Metrics'Class)
       return Qt4.Q_Integer;

   function Min_Left_Bearing
    (Self : Q_Font_Metrics'Class)
       return Qt4.Q_Integer;

   function Min_Right_Bearing
    (Self : Q_Font_Metrics'Class)
       return Qt4.Q_Integer;

   function Overline_Pos
    (Self : Q_Font_Metrics'Class)
       return Qt4.Q_Integer;

   function Right_Bearing
    (Self : Q_Font_Metrics'Class;
     Ch : Qt4.Chars.Q_Char'Class)
       return Qt4.Q_Integer;

   function Strike_Out_Pos
    (Self : Q_Font_Metrics'Class)
       return Qt4.Q_Integer;

   function Tight_Bounding_Rect
    (Self : Q_Font_Metrics'Class;
     Str : Qt4.Strings.Q_String'Class)
       return Qt4.Rects.Q_Rect;

   function Underline_Pos
    (Self : Q_Font_Metrics'Class)
       return Qt4.Q_Integer;

   function Width
    (Self : Q_Font_Metrics'Class;
     Text : Qt4.Strings.Q_String'Class;
     Len : Qt4.Q_Integer
       := -1)
       return Qt4.Q_Integer;

   function Width
    (Self : Q_Font_Metrics'Class;
     Ch : Qt4.Chars.Q_Char'Class)
       return Qt4.Q_Integer;

   function X_Height
    (Self : Q_Font_Metrics'Class)
       return Qt4.Q_Integer;

   overriding function "="
    (Self : Q_Font_Metrics;
     Other : Q_Font_Metrics)
       return Boolean;

   package Internals is

      type QFontMetrics is private;

      type QFontMetrics_Access is access all QFontMetrics;
      pragma Convention (C, QFontMetrics_Access);

      function QFontMetrics_View
       (Item : Q_Font_Metrics'Class)
          return QFontMetrics_Access;
      pragma Inline (QFontMetrics_View);

      function To_Pointer
       (Address : System.Address)
          return QFontMetrics_Access;
      pragma Inline (To_Pointer);

      function To_Address
       (Pointer : QFontMetrics_Access)
          return System.Address;
      pragma Inline (To_Address);

      function Create_Wrapper
       (Item : Internals.QFontMetrics_Access)
          return Q_Font_Metrics;

      function Create_Uninitialized return Q_Font_Metrics;

      function Storage
       (Item : Q_Font_Metrics'Class)
          return System.Address;
      pragma Inline (Storage);

      procedure Set_QFontMetrics_View
       (Item : in out Q_Font_Metrics'Class;
        View : QFontMetrics_Access);
      pragma Inline (Set_QFontMetrics_View);

   private

      type QFontMetrics is record
         Placeholder : Interfaces.C.char_array (1 .. Qt_Ada.Internals.Value_Class_Sizes.QFontMetrics_C_Size_Of);
      end record;
      pragma Convention (C, QFontMetrics);

   end Internals;

private

   type Q_Font_Metrics is new Ada.Finalization.Controlled with record
      Storage : aliased Internals.QFontMetrics;
      Object  : Internals.QFontMetrics_Access := null;
      Wrapper : Boolean := False;
   end record;

   overriding
   procedure Adjust (Self : in out Q_Font_Metrics);

   overriding
   procedure Finalize (Self : in out Q_Font_Metrics);

end Qt4.Font_Metrics;
